      IMPLICIT REAL*16 (A - H,O - Z)
      REAL*16, ALLOCATABLE :: WG(:),XG(:,:)
C
      OPEN (12,FILE='OUTPUT_F_6D.DAT')
      IOUT = 14
C
      EX = 6 - 1957 * EXP(-1Q0) / 120
C
      DO IP = 1 , 10
C
        IF (IP .EQ.  1) OPEN (IOUT,FILE='dd6o04_0043.dat')
        IF (IP .EQ.  2) OPEN (IOUT,FILE='dd6o05_0064.dat')
        IF (IP .EQ.  3) OPEN (IOUT,FILE='dd6o06_0175.dat')
        IF (IP .EQ.  4) OPEN (IOUT,FILE='dd6o07_0252.dat')
        IF (IP .EQ.  5) OPEN (IOUT,FILE='dd6o08_0448.dat')
        IF (IP .EQ.  6) OPEN (IOUT,FILE='dd6o08_0477.dat')
        IF (IP .EQ.  7) OPEN (IOUT,FILE='dd6o09_0700.dat')
        IF (IP .EQ.  8) OPEN (IOUT,FILE='dd6o09_0715.dat')
        IF (IP .EQ.  9) OPEN (IOUT,FILE='dd6o10_1078.dat')
        IF (IP .EQ. 10) OPEN (IOUT,FILE='dd6o10_1079.dat')
C
        READ(IOUT,*)
        READ(IOUT,*) IDIM,NP,NPT
        ALLOCATE (WG(NPT),XG(IDIM+1,NPT))
        CALL INQSIM(IOUT,IDIM,NPT,WG,XG)
        CLOSE(IOUT)
C
        SUM_FUN = 0Q0
        DO I = 1 , NPT
          SUM_FUN = SUM_FUN + WG(I) * FF(IDIM,XG(1,I))
        END DO
        SUM_FUN = SUM_FUN / 720
        WRITE(* ,123) IDIM,NP,NPT,SUM_FUN - EX
        WRITE(12,123) IDIM,NP,NPT,SUM_FUN - EX
C
        DEALLOCATE (WG,XG)
C
      END DO
123   FORMAT(2X,'DIM =',I2,2X,'ORDER =',I3,2X,'GNODES =',I5,
     1       2X,'NUM - EXACT =',G18.10)
      END
C
      FUNCTION FF(IDIM,XX)
      IMPLICIT REAL*16 (A - H,O - Z)
      DIMENSION XX(IDIM+1)
      SUM = 0Q0
      DO I = 1 , IDIM
        SUM = SUM + XX(I)
      END DO
      FF = SUM * EXP(-SUM)
      RETURN
      END
C
      SUBROUTINE INQSIM(IOUT,IDIM,NPT,WG,XG)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                                                                      C
C                        I N P U T  D A T A                            C
C                        ------------------                            C
C                                                                      C
C IOUT    INTEGER    number of the input ddxoy_z.dat file for reading  C
C                    informations of the PI-type fully symmetric       C
C                    quadrature rules in barycentric coordinates       C
C                    in compact form.                                  C
C IDIM    INTEGER    dimension of simplex.                             C
C NPT     INTEGER    number of nodes.                                  C
C                                                                      C
C----------------------------------------------------------------------C
C                                                                      C
C                                                                      C
C                        O U T P U T  D A T A                          C
C                        --------------------                          C
C                                                                      C
C WG      REAL*16    array of weights with dimension of NPT.           C
C XG      REAL*16    array of barycentric coordinates of nodes         C
C                    with dimension OF (IDIM + 1) x NPT.               C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      IMPLICIT REAL*16 (A - H,O - Z)
      DIMENSION IORB(0:14),WG(NPT),XG(IDIM+1,NPT)
      DIMENSION ISORB(14),IPERM(14),INORB(14,7)
      INTEGER, ALLOCATABLE :: IGL(:,:)
      REAL*16, ALLOCATABLE :: XX(:)
C
      CALL ORBINF(IDIM,NORB,ISORB,IPERM,INORB)
      READ(IOUT,*)
      READ(IOUT,*) (IORB(I),I=0,NORB-1)
      DO MAXORB = NORB - 1 , 1 , -1
          IF (IORB(MAXORB) .NE. 0) GO TO 12
      END DO
12    N = IPERM(MAXORB)
C
      IDIM1 = IDIM + 1
      ALLOCATE (IGL(IDIM1,N),XX(IDIM1))
C
      IGNODES = 0
      IF (IORB(0) .EQ. 1) THEN
         IGNODES = IGNODES + 1
         READ(IOUT,*) WG(IGNODES)
         DO J = 1 , IDIM1
            XG(J,IGNODES) = 1Q0 / IDIM1
         END DO
      END IF
C
      DO I1 = 1 , MAXORB
C
        IF (IORB(I1) .NE. 0) THEN
          CALL GRDD(I1,N,IGL,J0,IDIM,NORB,ISORB,IPERM,INORB)
        END IF
        DO I2 = 1 , IORB(I1)
          IDN = 0
          READ(IOUT,*) WW
          SX = 0Q0
          DO I3 = 1 , ISORB(I1) - 1
            IDN = IDN + 1
            READ(IOUT,*) XX(IDN)
            SX = SX + INORB(I1,I3) * XX(IDN)
          END DO
          IDN = IDN + 1
          XX(IDN) = (1 - SX) / INORB(I1,ISORB(I1))
          DO I4 = 1 , J0
            IGNODES = IGNODES + 1
            WG(IGNODES) = WW
            DO I5 = 1 , IDIM1
               XG(I5,IGNODES) = XX(IGL(I5,I4))
            END DO
          END DO
        END DO
C
      END DO
C
      DEALLOCATE (IGL,XX)
      RETURN
      END
C
      SUBROUTINE GRDD(IS,N,IGL,J0,IDIM,NORB,ISORB,IPERM,INORB)
      IMPLICIT REAL*16 (A - H,O - Z)
      DIMENSION ISORB(14),IPERM(14),INORB(14,7)
      DIMENSION IGL(IDIM+1,N)
      INTEGER, ALLOCATABLE :: IXLL(:)
      LOGICAL MORE
C
      IDIM1 = IDIM + 1
      ALLOCATE (IXLL(IDIM1))
C
      II = 0
      DO II1 = 1,  ISORB(IS)
        DO II2 = 1 , INORB(IS,II1)
          II = II + 1
          IXLL(II) = II1
        END DO
      END DO
C
      MORE = .TRUE.
      J0 = 1
      DO L = 1 , IDIM1
        IGL(L,J0) = IXLL(L)
      END DO
C
      DO I = 1 , IPERM(IS) - 1
          J0 = J0 + 1
          CALL MULTIPERM_NEXT ( IDIM1 , IXLL , MORE )
          DO L = 1 , IDIM1
            IGL(L,J0) = IXLL(L)
          END DO
      END DO
C
      DEALLOCATE (IXLL)
      RETURN
      END
C
      SUBROUTINE ORBINF(IDIM,NORB,ISORB,IPERM,INORB)
      IMPLICIT REAL*16 (A - H,O - Z)
      DIMENSION ISORB(14),IPERM(14),INORB(14,7)
C
      IF (IDIM .EQ. 2) THEN
C
          NORB = 3
          ISORB(1) = 2
          ISORB(2) = 3
C
          IPERM(1) = 3
          IPERM(2) = 6
C
          INORB(1,1  ) = 2
          INORB(1,2  ) = 1
          INORB(2,1:3) = 1
C
      END IF
C
      IF (IDIM .EQ. 3) THEN
C
          NORB = 5
          ISORB(1:2) = 2
          ISORB(3  ) = 3
          ISORB(4  ) = 4
C
          IPERM(1) = 4
          IPERM(2) = 6
          IPERM(3) = 12
          IPERM(4) = 24
C
          INORB(1,1  ) = 3
          INORB(1,2  ) = 1
          INORB(2,1:2) = 2
          INORB(3,1  ) = 2
          INORB(3,2:3) = 1
          INORB(4,1:4) = 1
C
      END IF
C
      IF (IDIM .EQ. 4) THEN
C
          NORB = 7
          ISORB(1:2) = 2
          ISORB(3:4) = 3
          ISORB(5  ) = 4
          ISORB(6  ) = 5
C
          IPERM(1) = 5
          IPERM(2) = 10
          IPERM(3) = 20
          IPERM(4) = 30
          IPERM(5) = 60
          IPERM(6) = 120
C
          INORB(1,1  ) = 4
          INORB(1,2  ) = 1
          INORB(2,1  ) = 3
          INORB(2,2  ) = 2
          INORB(3,1  ) = 3
          INORB(3,2:3) = 1
          INORB(4,1:2) = 2
          INORB(4,3  ) = 1
          INORB(5,1  ) = 2
          INORB(5,2:4) = 1
          INORB(6,1:5) = 1
C
      END IF
C
      IF (IDIM .EQ. 5) THEN
C
          NORB = 11
          ISORB(1 :3) = 2
          ISORB(4 :6) = 3
          ISORB(7 :8) = 4
          ISORB(9   ) = 5
          ISORB(10  ) = 6
C
          IPERM(1)  = 6
          IPERM(2)  = 15
          IPERM(3)  = 20
          IPERM(4)  = 30
          IPERM(5)  = 60
          IPERM(6)  = 90
          IPERM(7)  = 120
          IPERM(8)  = 180
          IPERM(9)  = 360
          IPERM(10) = 720
C
          INORB(1 ,1  ) = 5
          INORB(1 ,2  ) = 1
          INORB(2 ,1  ) = 4
          INORB(2 ,2  ) = 2
          INORB(3 ,1:2) = 3
          INORB(4 ,1  ) = 4
          INORB(4 ,2:3) = 1
          INORB(5 ,1  ) = 3
          INORB(5 ,2  ) = 2
          INORB(5 ,3  ) = 1
          INORB(6 ,1:3) = 2
          INORB(7 ,1  ) = 3
          INORB(7 ,2:4) = 1
          INORB(8 ,1:2) = 2
          INORB(8 ,3:4) = 1
          INORB(9 ,1  ) = 2
          INORB(9 ,2:5) = 1
          INORB(10,1:6) = 1
C
      END IF
C
      IF (IDIM .EQ. 6) THEN
C
          NORB = 15
          ISORB(1 :3 ) = 2
          ISORB(4 :7 ) = 3
          ISORB(8 :10) = 4
          ISORB(11:12) = 5
          ISORB(13   ) = 6
          ISORB(14   ) = 7
C
          IPERM(1)  = 7
          IPERM(2)  = 21
          IPERM(3)  = 35
          IPERM(4)  = 42
          IPERM(5)  = 105
          IPERM(6)  = 140
          IPERM(7)  = 210
          IPERM(8)  = 210
          IPERM(9)  = 420
          IPERM(10) = 630
          IPERM(11) = 840
          IPERM(12) = 1260
          IPERM(13) = 2520
          IPERM(14) = 5040
C
          INORB(1 ,1  ) = 6
          INORB(1 ,2  ) = 1
          INORB(2 ,1  ) = 5
          INORB(2 ,2  ) = 2
          INORB(3 ,1  ) = 4
          INORB(3 ,2  ) = 3
          INORB(4 ,1  ) = 5
          INORB(4 ,2:3) = 1
          INORB(5 ,1  ) = 4
          INORB(5 ,2  ) = 2
          INORB(5 ,3  ) = 1
          INORB(6 ,1:2) = 3
          INORB(6 ,3  ) = 1
          INORB(7 ,1  ) = 3
          INORB(7 ,2:3) = 2
          INORB(8 ,1  ) = 4
          INORB(8 ,2:4) = 1
          INORB(9 ,1  ) = 3
          INORB(9 ,2  ) = 2
          INORB(9 ,3:4) = 1
          INORB(10,1:3) = 2
          INORB(10,4  ) = 1
          INORB(11,1  ) = 3
          INORB(11,2:5) = 1
          INORB(12,1:2) = 2
          INORB(12,3:5) = 1
          INORB(13,1  ) = 2
          INORB(13,2:6) = 1
          INORB(14,1:7) = 1
C
      END IF
      RETURN
      END


      subroutine multiperm_next ( n, a, more )

c*****************************************************************************80
c
c! MULTIPERM_NEXT returns the next multipermutation.
c
c  Discussion:
c
c    A multipermutation is a permutation of objects, some of which are
c    identical.
c
c    While there are 6 permutations of the distinct objects A,B,C, there
c    are only 3 multipermutations of the objects A,B,B.
c
c    In general, there are N! permutations of N distinct objects, but
c    there are N! / ( ( M1! ) ( M2! ) ... ( MK! ) ) multipermutations
c    of N objects, in the case where the N objects consist of K
c    types, with M1 examples of type 1, M2 examples of type 2 and so on,
c    and for which objects of the same type are indistinguishable.
c
c    To begin the computation, the user must set up the first multipermutation.
c    To compute ALL possible multipermutations, this first permutation should
c    list the values in ascending order.
c
c    The routine will compute, one by one, the next multipermutation,
c    in lexicographical order.  On the call after computing the last
c    multipermutation, the routine will return MORE = FALSE (and will
c    reset the multipermutation to the FIRST one again.)
c
c  Example:
c
c    1  1 2 2 3 3
c    2  1 2 3 2 3
c    3  1 2 3 3 2
c    4  1 3 2 2 3
c    5  1 3 2 3 2
c    6  1 3 3 2 2
c    7  2 1 2 3 3
c    8  2 1 3 2 3
c    ...
c   30  3 3 2 2 1
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    07 March 2007
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer ( kind = 4 ) N, the number of items in the multipermutation.
c
c    Input/output, integer ( kind = 4 ) A(N); on input, the current
c    multipermutation.  On output, the next multipermutation.
c
c    Output, logical MORE, is TRUE if the next multipermutation
c    was computed, or FALSE if no further multipermutations could
c    be computed.
c
      implicit none

      integer ( kind = 4 ) n

      integer ( kind = 4 ) a(n)
      integer ( kind = 4 ) i
      integer ( kind = 4 ) m
      logical more
      integer ( kind = 4 ) temp
c
c  Step 1:
c  Find M, the last location in A for which A(M) < A(M+1).
c
      m = 0
      do i = 1, n - 1
        if ( a(i) < a(i+1) ) then
          m = i
        end if
      end do
c
c  Step 2:
c  If no M was found, we've run out of multipermutations.
c
      if ( m == 0 ) then
        more = .false.
        call i4vec_sort_heap_a ( n, a )
        return
      else
        more = .true.
      end if
c
c  Step 3:
c  Ascending sort A(M+1:N).
c
      if ( m + 1 < n ) then
        call i4vec_sort_heap_a ( n-m, a(m+1:n) )
      end if
c
c  Step 4:
c  Locate the first larger value after A(M).
c
      i = 1
      do while ( a(m+i) <= a(m) )
        i = i + 1
      end do
c
c  Step 5:
c  Interchange A(M) and the next larger value.
c
      temp = a(m)
      a(m) = a(m+i)
      a(m+i) = temp

      return
      end

      subroutine i4vec_sort_heap_a ( n, a )

c*****************************************************************************80
c
c! I4VEC_SORT_HEAP_A ascending sorts an I4VEC using heap sort.
c
c  Discussion:
c
c    An I4VEC is a vector of integer values.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    15 April 1999
c
c  Author:
c
c    John Burkardt
c
c  Reference:
c
c    Albert Nijenhuis, Herbert Wilf,
c    Combinatorial Algorithms,
c    Academic Press, 1978, second edition,
c    ISBN 0-12-519260-6.
c
c  Parameters:
c
c    Input, integer ( kind = 4 ) N, the number of entries in the array.
c
c    Input/output, integer ( kind = 4 ) A(N).
c    On input, the array to be sorted;
c    On output, the array has been sorted.
c
      implicit none

      integer ( kind = 4 ) n

      integer ( kind = 4 ) a(n)
      integer ( kind = 4 ) n1
      integer ( kind = 4 ) t

      if ( n <= 1 ) then
        return
      end if
c
c  1: Put A into descending heap form.
c
      call i4vec_heap_d ( n, a )
c
c  2: Sort A.
c
c  The largest object in the heap is in A(1).
c  Move it to position A(N).
c
      t    = a(1)
      a(1) = a(n)
      a(n) = t
c
c  Consider the diminished heap of size N1.
c
      do n1 = n - 1, 2, -1
c
c  Restore the heap structure of A(1) through A(N1).
c
        call i4vec_heap_d ( n1, a )
c
c  Take the largest object from A(1) and move it to A(N1).
c
        t     = a(1)
        a(1)  = a(n1)
        a(n1) = t

      end do

      return
      end
      subroutine i4vec_heap_d ( n, a )

c*****************************************************************************80
c
c! I4VEC_HEAP_D reorders an I4VEC into an descending heap.
c
c  Discussion:
c
c    An I4VEC is a vector of integer values.
c
c    A descending heap is an array A with the property that, for every index J,
c    A(J) >= A(2*J) and A(J) >= A(2*J+1), (as long as the indices
c    2*J and 2*J+1 are legal).
c
c                  A(1)
c                /      \
c            A(2)         A(3)
c          /     \        /  \
c      A(4)       A(5)  A(6) A(7)
c      /  \       /   \
c    A(8) A(9) A(10) A(11)
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    15 April 1999
c
c  Author:
c
c    John Burkardt
c
c  Reference:
c
c    Albert Nijenhuis, Herbert Wilf,
c    Combinatorial Algorithms,
c    Academic Press, 1978, second edition,
c    ISBN 0-12-519260-6.
c
c  Parameters:
c
c    Input, integer ( kind = 4 ) N, the size of the input array.
c
c    Input/output, integer ( kind = 4 ) A(N).
c    On input, an unsorted array.
c    On output, the array has been reordered into a heap.
c
      implicit none

      integer ( kind = 4 ) n

      integer ( kind = 4 ) a(n)
      integer ( kind = 4 ) i
      integer ( kind = 4 ) ifree
      integer ( kind = 4 ) key
      integer ( kind = 4 ) m
c
c  Only nodes N/2 down to 1 can be "parent" nodes.
c
      do i = n / 2, 1, -1
c
c  Copy the value out of the parent node.
c  Position IFREE is now "open".
c
        key = a(i)
        ifree = i

        do
c
c  Positions 2*IFREE and 2*IFREE + 1 are the descendants of position
c  IFREE.  (One or both may not exist because they exceed N.)
c
          m = 2 * ifree
c
c  Does the first position exist?
c
          if ( n < m ) then
            exit
          end if
c
c  Does the second position exist?
c
          if ( m + 1 <= n ) then
c
c  If both positions exist, take the larger of the two values,
c  and update M if necessary.
c
            if ( a(m) < a(m+1) ) then
              m = m + 1
            end if

          end if
c
c  If the large descendant is larger than KEY, move it up,
c  and update IFREE, the location of the free position, and
c  consider the descendants of THIS position.
c
          if ( a(m) <= key ) then
            exit
          end if

          a(ifree) = a(m)
          ifree = m

        end do
c
c  Once there is no more shifting to do, KEY moves into the free spot IFREE.
c
        a(ifree) = key

      end do

      return
      end